<?php

/**
 * The following container integrates the Plupload (http://www.plupload.com)
 * component, allowing you to add multiple images interactively.
 * If you want to change settings, first check the documentation component
 * (http://www.plupload.com/documentation.php)
 * Usage:
 * <?php $this->widget('ext.plupload.Plupload'); ?>
 * @version 1.1
 * @author Rafael J Torres <rafaelt88@gmail.com>
 * @copyright (c) 2014 Rafael J Torres
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 */
class Plupload extends CWidget {
    public $types;

    public function init() {
        $assets = Yii::app()->assetManager->publish(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'assets');
        Yii::app()->clientscript->registerCssFile(
            '//ajax.googleapis.com/ajax/libs/jqueryui/1.8.9/themes/base/jquery-ui.css')
            ->registerCssFile($assets . '/css/jquery.ui.plupload.css')
            ->registerScriptFile($assets . '/js/plupload.full.min.js', CClientScript::POS_HEAD)
            ->registerScriptFile($assets . '/js/jquery.ui.plupload.js', CClientScript::POS_HEAD)
            ->registerScriptFile($assets . '/js/i18n/' . Yii::app()->language . '.js', CClientScript::POS_HEAD)
            ->registerCoreScript('jquery.ui');
        $this->types = $this->types ? $this->types : array(
            array(
                "title" => "Image files",
                "extensions" => "jpg,gif,png"
            )
        );
    }

    public function run() {
        Yii::app()->clientscript->registerScript('plupload', 
            '$(function() {
            $.fn.btn = $.fn.button.noConflict();
            var uploader = $("#uploader").plupload({
                url : "../site/upload",
                max_file_size: "2mb",
                prevent_duplicates: true,
                filters : ' . json_encode($this->types) . ',
                rename: true,
                sortable: true,
                dragdrop: true,
                unique_names: true,
                views: {
                    list: true,
                    thumbs: true,
                    active: "thumbs"
                },
                init: {UploadComplete: function (up, files) {updateForm(files);}
                }
            });
        });', CClientScript::POS_READY);
        echo "<div id='uploader'>";
        echo "<p>Your browser doesn't have Flash, Silverlight or HTML5 support.</p>";
        echo "</div>";
    }

}