<?php
require_once dirname(__FILE__) . '/../helpers.php';

/**
 * The following container integrates the Plupload (http://www.plupload.com)
 * component, allowing you to add multiple images interactively.
 * If you want to change settings, first check the documentation component
 * (http://www.plupload.com/documentation.php)
 * Usage:
 * Embed the action in the controller that makes the call:
 * public function actions() {
 * ...
 * 'upload' => 'ext.plupload.actions.UploadAction',
 * ...
 * }
 * @version 1.0
 * @author Rafael J Torres <rafaelt88@gmail.com>
 * @copyright (c) 2014 Rafael J Torres
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 */
class UploadAction extends CAction {
    public $basePath = PLUPLOAD_ROOT;
    public $baseUrl;

    public function run() {
        $this->prepare();
        if ($file = new CUploadedFile($_FILES['file']['name'], $_FILES['file']['tmp_name'], $_FILES['file']['type'], 
            $_FILES['file']['size'], $_FILES['file']['error'])) {
            if ($file->saveAs($this->basePath . md5Name($file->getName()))) {
                appendList($file->getName());
            }
        }
    }

    public function prepare() {
        @set_time_limit(5 * 60);
        $this->baseUrl = $this->basePath .= date('Y/m/d/');
        $this->basePath = str_replace('/', DIRECTORY_SEPARATOR, $this->basePath);
        if (! file_exists($this->basePath)) {
            @mkdir($this->basePath, 0775, true);
        }
    }

}
